Skip to main content Skip to footer

Displaying UTC Time in FlexGrid Date Columns in JavaScript

Background

If your data source contains date-time values like in SGT, Singapore Time, but you want to display those values in UTC inside Wijmo FlexGrid, use the column cellTemplate property. This lets FlexGrid stay bound to the original date values while displaying UTC-formatted text in the grid cells.

Steps to Complete

  1. Install the required Wijmo packages.
  2. Prepare the SGT date-time values as JavaScript Date objects.
  3. Create a reusable UTC formatter.
  4. Create the FlexGrid and define columns.
  5. Use cellTemplate to display date values in UTC.

Getting Started

Install the required Wijmo packages

npm install @mescius/wijmo @mescius/wijmo.grid @mescius/wijmo.grid.filter @mescius/wijmo.styles
import '@mescius/wijmo.styles/wijmo.css';
import { FlexGrid } from '@mescius/wijmo.grid';
import { FlexGridFilter } from '@mescius/wijmo.grid.filter';
  • These packages provide the core Wijmo runtime, FlexGrid, optional filtering, and the required Wijmo styles.

 

Prepare the SGT date-time values as JavaScript Date objects

const rawData = [
  {
    id: 1,
    task: 'Order created',
    startTime: '2026-06-25T09:30:00+08:00'
  },
  {
    id: 2,
    task: 'Order shipped',
    startTime: '2026-06-25T14:00:00+08:00'
  }
];

const data = rawData.map(item => ({
  ...item,
  startTime: new Date(item.startTime)
}));
  • The +08:00 offset identifies the source value as SGT. Converting it to a Date object preserves the correct instant in time for UTC formatting.

 

Create a reusable UTC formatter

const utcFormatter = new Intl.DateTimeFormat('en-GB', {
  year: 'numeric',
  month: '2-digit',
  day: '2-digit',
  hour: '2-digit',
  minute: '2-digit',
  second: '2-digit',
  hour12: false,
  timeZone: 'UTC',
  timeZoneName: 'short'
});

function formatUtc(value) {
  if (!value) {
    return '';
  }

  const date = value instanceof Date ? value : new Date(value);
  return Number.isNaN(date.getTime()) ? '' : utcFormatter.format(date);
}
  • The formatter uses timeZone: 'UTC', so each value is displayed in UTC regardless of the user’s browser time zone.

 

Create the FlexGrid and define columns

<div id="theGrid"></div>
const grid = new FlexGrid('#theGrid', {
  autoGenerateColumns: false,
  itemsSource: data,
  columns: [
    { header: 'ID', binding: 'id', width: 70 },
    { header: 'Task', binding: 'task', width: '*' },
    { header: 'Start Time (UTC)', binding: 'startTime', width: 220 }
  ]
});
  • Setting autoGenerateColumns to false lets you define the date-time column manually.

 

Use cellTemplate to display date values in UTC

const grid = new FlexGrid('#theGrid', {
  autoGenerateColumns: false,
  itemsSource: data,
  columns: [
    { header: 'ID', binding: 'id', width: 70 },
    { header: 'Task', binding: 'task', width: '*' },
    {
      header: 'Start Time (UTC)',
      binding: 'startTime',
      width: 220,
      cellTemplate: ctx => formatUtc(ctx.value)
    }
  ]
});
  • The column remains bound to startTime, but cellTemplate controls the displayed cell content. The original date value is still available for grid operations such as sorting and filtering.

 

With this JavaScript setup, FlexGrid can continue binding to the original date-time values while displaying each date column in UTC. The cellTemplate property handles the display conversion, so users see UTC-formatted dates without requiring changes to the original data source.

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Displaying UTC Time in FlexGrid Date Columns in Angular

Background

If your data source contains date-time values in SGT, Singapore Time, but you want to display those values in UTC inside Wijmo FlexGrid, use the Angular wjFlexGridCellTemplate directive on the required date-time columns. This lets FlexGrid stay bound to the original date values while displaying UTC-formatted text in the grid cells.

Steps to Complete

  1. Install the required Wijmo Angular packages.
  2. Import the Wijmo grid modules.
  3. Prepare the SGT date-time values as JavaScript Date objects.
  4. Create a reusable UTC formatter.
  5. Add a FlexGrid column cell template.

Getting Started

Install the required Wijmo Angular packages

npm install @mescius/wijmo.angular2.grid @mescius/wijmo.angular2.grid.filter @mescius/wijmo.styles

In styles.css, import the Wijmo stylesheet:

@import '@mescius/wijmo.styles/wijmo.css';
  • These packages provide the Angular FlexGrid components, the optional grid filter component, and the required Wijmo styles.

 

Import the Wijmo grid modules

import { Component } from '@angular/core';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGridFilterModule } from '@mescius/wijmo.angular2.grid.filter';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [WjGridModule, WjGridFilterModule],
  templateUrl: './app.component.html'
})
export class AppComponent {}
  • WjGridModule enables wj-flex-grid, wj-flex-grid-column, and wjFlexGridCellTemplate. WjGridFilterModule enables wj-flex-grid-filter.

 

Prepare the SGT date-time values as JavaScript Date objects

rawData = [
  {
    id: 1,
    task: 'Order created',
    startTime: '2026-06-25T09:30:00+08:00'
  },
  {
    id: 2,
    task: 'Order shipped',
    startTime: '2026-06-25T14:00:00+08:00'
  }
];

data = this.rawData.map(item => ({
  ...item,
  startTime: new Date(item.startTime)
}));
  • The +08:00 offset identifies the source value as SGT. Converting it to a Date object preserves the correct instant in time for UTC formatting.

 

Create a reusable UTC formatter

utcFormatter = new Intl.DateTimeFormat('en-GB', {
  year: 'numeric',
  month: '2-digit',
  day: '2-digit',
  hour: '2-digit',
  minute: '2-digit',
  second: '2-digit',
  hour12: false,
  timeZone: 'UTC',
  timeZoneName: 'short'
});

formatUtc(value: Date | string | null): string {
  if (!value) {
    return '';
  }

  const date = value instanceof Date ? value : new Date(value);
  return Number.isNaN(date.getTime()) ? '' : this.utcFormatter.format(date);
}
  • The formatter uses timeZone: 'UTC', so each value is displayed in UTC regardless of the user’s local browser time zone.

 

Add a FlexGrid column cell template

<wj-flex-grid [itemsSource]="data" [autoGenerateColumns]="false">
  <wj-flex-grid-column [header]="'ID'" [binding]="'id'" [width]="70">
  </wj-flex-grid-column>

  <wj-flex-grid-column [header]="'Task'" [binding]="'task'" [width]="'*'">
  </wj-flex-grid-column>

  <wj-flex-grid-column [header]="'Start Time (UTC)'" [binding]="'startTime'" [width]="220">
    <ng-template wjFlexGridCellTemplate [cellType]="'Cell'" let-cell="cell">
      {{ formatUtc(cell.item.startTime) }}
    </ng-template>
  </wj-flex-grid-column>
</wj-flex-grid>
  • The column remains bound to startTime, but the ng-template controls the displayed cell content. The cell.item object gives access to the row’s data item.

 

With this Angular setup, FlexGrid can continue binding to the original date-time values while displaying each date column in UTC. The wjFlexGridCellTemplate directive handles the display conversion, so users see UTC-formatted dates without requiring changes to the original data source.

Andrew Peterson

Technical Engagement Engineer

Skip to main content Skip to footer

Displaying UTC Time in FlexGrid Date Columns in React

Background

When a data source contains date-time values like in SGT, or Singapore Time, you may need to display those values in UTC inside Wijmo FlexGrid. In React, this can be done by keeping the column bound to the original date value and using a FlexGridCellTemplate to render the cell text in UTC.

Steps to Complete

  1. Install and import the required Wijmo packages.
  2. Prepare the SGT date-time data as JavaScript Date objects.
  3. Create a reusable UTC formatter.
  4. Convert the source values to Date objects
  5. Add a FlexGrid with date-time columns.

Getting Started

Install and import the required Wijmo packages

npm install @mescius/wijmo @mescius/wijmo.react.grid @mescius/wijmo.react.grid.filter @mescius/wijmo.styles
import React, { useMemo } from 'react';
import '@mescius/wijmo.styles/wijmo.css';
import { FlexGrid, FlexGridColumn, FlexGridCellTemplate } from '@mescius/wijmo.react.grid';
import { FlexGridFilter } from '@mescius/wijmo.react.grid.filter';
  • These packages provide the React FlexGrid components, cell template support, optional filtering, and Wijmo styles.

 

Prepare the SGT date-time data as JavaScript Date objects

const rawData = [
  {
    id: 1,
    task: 'Order created',
    startTime: '2026-06-25T09:30:00+08:00'
  },
  {
    id: 2,
    task: 'Order shipped',
    startTime: '2026-06-25T14:00:00+08:00'
  }
];
  • The +08:00 offset tells JavaScript that the source value is in SGT. This is important because JavaScript can then convert the same instant correctly to UTC.

 

Create a reusable UTC formatter

const utcFormatter = new Intl.DateTimeFormat('en-GB', {
  year: 'numeric',
  month: '2-digit',
  day: '2-digit',
  hour: '2-digit',
  minute: '2-digit',
  second: '2-digit',
  hour12: false,
  timeZone: 'UTC',
  timeZoneName: 'short'
});

function formatUtc(value) {
  if (!value) {
    return '';
  }

  const date = value instanceof Date ? value : new Date(value);
  return Number.isNaN(date.getTime()) ? '' : utcFormatter.format(date);
}
  • The formatter uses timeZone: 'UTC', so every date passed to it is displayed as UTC time.

 

Convert the source values to Date objects

const data = useMemo(
  () =>
    rawData.map(item => ({
      ...item,
      startTime: new Date(item.startTime)
    })),
  []
);
  • This keeps the grid bound to actual date values instead of plain strings, which is better for sorting, filtering, and editing behavior.

 

Add a FlexGrid with date-time columns

<FlexGrid itemsSource={data} autoGenerateColumns={false}>
  <FlexGridColumn binding="id" header="ID" width={70} />
  <FlexGridColumn binding="task" header="Task" width="*" />

  <FlexGridColumn binding="startTime" header="Start Time (UTC)" width={220}>
    <FlexGridCellTemplate
      cellType="Cell"
      template={context => formatUtc(context.item.startTime)}
    />
  </FlexGridColumn>
</FlexGrid>
  • The FlexGridColumn remains bound to startTime, but the FlexGridCellTemplate controls what users see in the cell. Here, the template renders the value in UTC.

 

With this React setup, FlexGrid can continue binding to the original date-time values while displaying each date column in UTC. The FlexGridCellTemplate handles the display conversion, so users see UTC-formatted dates in the grid without requiring changes to the underlying data source.

Andrew Peterson

Technical Engagement Engineer